/*********************************************************************
*                                                                    *          
*                              FLY                                   *
*                           --E#Y#E--	    			     *
*                         ===MUSCLE===                               *
*                                                                    *
*********************************************************************/
/* Header Files */
#include "opengl.h"
 
/* #define UNI */
#define MOT 
#define COK 

/* Texture */
GLubyte *bla;
GLubyte *des;
GLubyte *sky;
GLubyte *sea;

/* GLfloat */
GLfloat roll;
GLfloat yaw;
GLfloat pitch;
GLfloat planeX;
GLfloat planeY;
GLfloat planeZ;
GLfloat rootY;
GLfloat viewZ;
GLfloat nightV;

/* RGB Colour */
float VA1;    
float VA7;
float VA8;

/* Render Texture */
float projection[ID];
float modelview[ID];

/*---------------------------------------------------------------------------*/ 

float circel[7][7] = {
	
{0.00,0.00,0.00,0.00,0.00, 0},
{0.00,0.00,0.00,0.00,0.00, 0},
{0.00,0.00,0.00,0.00,0.00, 0},
{0.00,0.00,0.00,0.00,0.00, 0},
{0.00,0.00,0.00,0.00,0.00, 0}};

/*---------------------------------------------------------------------------*/ 

unsigned int way[27][27] = {
	
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/
 {0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,1,0,0,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,1,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0, 0},
 {0,1,1,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,1,1,0,1,0,0,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0, 0},
 {0,0,0,1,1,0,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,1,0,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,0,0, 0},
 {0,1,0,0,0,0,1,0,1,1,1,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,1,1,0,1,0,0,0,0,0,0,0,0,1,1,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,1,0,0,0,0,1,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,1,0,1,0,0,0,1,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,1,0,1,0,0,0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,1,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,1,0,1,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0, 0},
 {1,0,1,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,1,0,1,0,0,0,0, 0},
 {0,0,1,0,1,0,0,0,0,0,0,0,0,0,0,1,0,1,0,0,1,1,0,0,0, 0},
 {0,0,0,0,1,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1,0,0, 0},
 {0,0,0,0,0,0,1,0,1,0,0,0,0,0,0,1,0,0,0,1,1,0,0,1,0, 0},
 {0,0,0,0,0,0,0,0,1,0,0,0,0,0,0,0,0,0,1,0,0,0,0,1,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,0,0,1,0,1,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0,0,0, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,1, 0},
 {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,0,1,0, 0}};
/*A B C D E F G H I J K L M N O P Q R S T U V W X Y*/

/*---------------------------------------------------------------------------*/    

/* Load Textures */
void loadPNG()
{
	/* Filename */	
	char *filename1;
	char *filename2;
	char *filename3;
	char *filename4;

	/* Textures */	
	filename1 = "C/PIXEL/forest.png";
	filename2 = "C/PIXEL/desert.png";
	filename3 = "C/PIXEL/cloud.png";
	filename4 = "C/PIXEL/sea.png";
	
	/* Load Textures */
	read_png(filename1, &bla);		
	read_png(filename2, &des);
	read_png(filename3, &sky);
	read_png(filename4, &sea);
}

/*---------------------------------------------------------------------------*/

/* Load Config */
void loadConfig()
{
	/* Config */
	int con1;
	int con2;
	int con3;

	char code1;
	char code2;
	char code3;
	
	FILE *config;
	
	/* Config File */
	config=fopen("C/DATA/config.fs","r");
	while(fscanf(config,"%s %d %s %d %s %d",
	&code1, &con1, &code2, &con2, &code3, &con3)!= EOF)
	{ 
		code1 = con1;
		code2 = con2;
		code3 = con3;
	}
	fclose(config);
}

/*---------------------------------------------------------------------------*/

/* Init Triangles */
void initGrid()
{	
	/* Background Color */
	glEnable(GL_BLEND);	
	glEnable(GL_DEPTH_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	/* Grid */
	glClearColor( 0.01f , 0.01f , 0.01f , 0.5f );
}

/*---------------------------------------------------------------------------*/  

/* Init Triangles */
void initLand(char night)
{	
	/* Background Color */
	glEnable(GL_BLEND);
	glEnable(GL_AMBIENT);
	glEnable(GL_LIGHT7);
	glEnable(GL_LIGHTING);	
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_COLOR_MATERIAL);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	
	/* Night */
	if(night)
	{	
		glClearColor( 0.10f , 0.20f , 0.30f , 0.5f );
		glDisable(GL_LIGHT7);	
	}
	/* Day */
	else
	{	
		glClearColor( 0.30f , 0.50f , 0.70f , 0.5f );
		glDisable(GL_LIGHTING);
	}
}

/*---------------------------------------------------------------------------*/

/* Shader Language */
void textureShader()
{
	#ifdef UNI
	/* Texture Shader */
	CreateShader();
	CreateProgram();
	Location(0, "a_Vertex");
	Location(1, "a_TexCoord");

	glEnableVertexAttribArray(0); 
    	glEnableVertexAttribArray(1); 

	/* Passing Data */
	glGetFloatv(GL_PROJECTION_MATRIX, projection);
	glGetFloatv(GL_MODELVIEW_MATRIX, modelview);

	/* Uniform and Matrix */
	Uniform4x4("modelview_matrix", modelview, 0);
	Uniform4x4("projection_matrix", projection, 0);
	Uniform("texture0", 0);

	/* Delete Shader */
	DeleteShader();
	#endif
}

/*---------------------------------------------------------------------------*/

/* Render Grid */
void GridView()
{
	/* Graph */
	char graph;
	
	FILE *gridfi;
	
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0.0, 0.0, 0.0);

	/* Camera Look */
	gluLookAt(0.0f, 2.0f, 20.0f, 
		  0.0f, 2.0f,-20.0f, 
		  0.0f, 5.0f, 0.0f);

	/* Rotation */
	glRotatef(-roll, 0.0f, 0.0f, 1.0f);
	glRotatef(-yaw, 0.0f, 1.0f, 0.0f);
	glRotatef(-pitch, 1.0f, 0.0f, 0.0f);
	glTranslatef(-planeX, -planeY, -planeZ);
	glLineWidth(1);
	glPointSize(5);
	
	/* Landscape File */
	gridfi=fopen("CPP/DATA/gridB.fs","r");
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_POINTS);
	/*glBegin(GL_TRIANGLES);*/
	glColor4f(0.0f, 0.9f, 0.9f, 1.0f);	
	while(fscanf(gridfi,"%s %f %f %f",
		&graph,&gl.tri.x,&gl.tri.y,&gl.tri.z)!= EOF)
	{ 
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	glEnd();
	fclose(gridfi);
	
	/* Landscape File */
	gridfi=fopen("C/DATA/gridB.fs","r");	
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_TRIANGLES);
	glColor4f(0.7f, 0.7f, 0.7f, 1.0f);	
	while(fscanf(gridfi,"%s %f %f %f",
		&graph,&gl.tri.x,&gl.tri.y,&gl.tri.z)!= EOF)
	{ 
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	glEnd();
	fclose(gridfi);	
}

/*---------------------------------------------------------------------------*/

/* Render Landscape */
void Landscape(char cloud)
{
	char code;
	
	/* Load File */
	FILE *forest;
	FILE *desert;
	FILE *seaoce;
	
	/* Render Triangles */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	glTranslatef(0.0, 0.0, 0.0);

	/* Camera Look */
	gluLookAt(0.0f, 2.0f, 20.0f, 
		  0.0f, 2.0f,-20.0f, 
		  0.0f, 5.0f, 0.0f);

	/* Rotation */
	glRotatef(-roll, 0.0f, 0.0f, 1.0f);
	glRotatef(-yaw, 0.0f, 1.0f, 0.0f);
	glRotatef(-pitch, 1.0f, 0.0f, 0.0f);
	glTranslatef(-planeX, -planeY, -planeZ);
	glLineWidth(1);

	/* Filtering Mode */
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_MIRRORED_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_MIRRORED_REPEAT);
	/*glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);*/
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);

	/* Landscape File */
	forest=fopen("C/DATA/forest.fs","r");
	desert=fopen("C/DATA/desert.fs","r");
	seaoce=fopen("C/DATA/seaoce.fs","r");

	/* Enable Texture */
	glEnable(GL_TEXTURE_2D);
	/* Image Data */
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGR,GL_UNSIGNED_BYTE,bla);
	/* Sub Image Data */
	glTexSubImage2D(GL_TEXTURE_2D,0,0,0,128,128,GL_BGR,GL_UNSIGNED_BYTE,bla);	
	glTexSubImage2D(GL_TEXTURE_2D,0,2,0,128,128,GL_BGR,GL_UNSIGNED_BYTE,bla);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,2,128,128,GL_BGR,GL_UNSIGNED_BYTE,bla);
	glTexSubImage2D(GL_TEXTURE_2D,0,2,2,128,128,GL_BGR,GL_UNSIGNED_BYTE,bla);

	/* Forest Triangles */
	glBegin(GL_TRIANGLES);
	while(fscanf(forest,"%s %f %f %f %f %f", &code, &gl.tex.s, &gl.tex.t, 
		&gl.tri.x, &gl.tri.y, &gl.tri.z) != EOF)
	{ 	
		glTexCoord2f(gl.tex.s, gl.tex.t);
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}
	glEnd();

	/* Image Data */
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,des);
	/* Sub Image Data */
	glTexSubImage2D(GL_TEXTURE_2D,0,0,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,des);	
	glTexSubImage2D(GL_TEXTURE_2D,0,2,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,des);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,des);
	glTexSubImage2D(GL_TEXTURE_2D,0,2,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,des);

	/* Desert Triangles */
	glBegin(GL_TRIANGLES);
	while(fscanf(desert,"%s %f %f %f %f %f", &code, &gl.tex.s, &gl.tex.t, 
		&gl.tri.x, &gl.tri.y, &gl.tri.z) != EOF)
	{ 	
		glTexCoord2f(gl.tex.s, gl.tex.t);
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}	
	glEnd();

	/* Image Data */
	glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,GL_BGRA,GL_UNSIGNED_BYTE,sea);
	/* Sub Image Data */
	glTexSubImage2D(GL_TEXTURE_2D,0,0,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,sea);	
	glTexSubImage2D(GL_TEXTURE_2D,0,2,0,128,128,GL_BGRA,GL_UNSIGNED_BYTE,sea);
	glTexSubImage2D(GL_TEXTURE_2D,0,0,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,sea);
	glTexSubImage2D(GL_TEXTURE_2D,0,2,2,128,128,GL_BGRA,GL_UNSIGNED_BYTE,sea);

	/* Sea Triangles */
	glBegin(GL_TRIANGLES);
	while(fscanf(seaoce,"%s %f %f %f %f %f", &code, &gl.tex.s, &gl.tex.t, 
		&gl.tri.x, &gl.tri.y, &gl.tri.z) != EOF)
	{ 	
		glTexCoord2f(gl.tex.s, gl.tex.t);
		glVertex3f(gl.tri.x, gl.tri.y, gl.tri.z);
	}	
	glEnd();
	
	/* Texture Cloud */
	if(cloud)
	{
		/* Image Data */
		glTexImage2D(GL_TEXTURE_2D,0,GL_RGBA,128,128,0,
				GL_BGRA,GL_UNSIGNED_BYTE,sky);
		/* Clouds */
		glBegin(GL_QUADS);
		glTexCoord2f(0.0,0.0);glVertex3f( 20.0f,4.0f, 20.0f);
		glTexCoord2f(2.0,0.0);glVertex3f( 20.0f,4.0f,-20.0f);
		glTexCoord2f(2.0,2.0);glVertex3f(-20.0f,4.0f,-20.0f);
		glTexCoord2f(0.0,2.0);glVertex3f(-20.0f,4.0f, 20.0f);
		glEnd();
	}
	
	/* File Close */	
	fclose(forest);
	fclose(desert);
	fclose(seaoce);
	
	/* Disable Texture */
	glDisable(GL_COLOR_MATERIAL);	
	glDisable(GL_TEXTURE_2D);
	glDisable(GL_LIGHTING);
	glDisable(GL_AMBIENT);
}

/*-------------------------------------------------------------------------*/

/* Render Cockpit */
void Cockpit()
{	
	/* Rotation */
	glRotatef(roll, 0.0f, 0.0f ,1.0f);
	glRotatef(yaw, 0.0f, 1.0f ,0.0f);
	glRotatef(pitch, 1.0f, 0.0f ,0.0f);
	glTranslatef(planeX, planeY + 2.0f, planeZ + viewZ + 18.499f);
	glTranslatef( 0.0, 0.0, 0.0);
	glLineWidth(2);
	glPointSize(15);

	#ifdef MOT
	/* Begin Motor ( 2. GL_LINE / 2. GL_FILL ) */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL); 
	glBegin(GL_TRIANGLES);

		/* Rost Metalic */
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.0f,  -0.4f,  0.0f );
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.0f,  -0.4f, -0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f( 0.5f,  -0.4f, -0.5f );
		
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.0f,  -0.4f,  0.0f );
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.0f,  -0.4f, -0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f(-0.5f,  -0.4f, -0.5f );
		
		/* 4 x 4 */
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f( 0.5f,  -0.4f, -0.5f );
		glVertex3f( 0.5f,  -0.4f, -1.0f );

		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f( 0.0f,  -0.4f, -1.0f );
		glVertex3f( 0.5f,  -0.4f, -1.0f );
		
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f(-0.5f,  -0.4f, -0.5f );
		glVertex3f(-0.5f,  -0.4f, -1.0f );

		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.0f,  -0.4f, -0.5f );
		glVertex3f( 0.0f,  -0.4f, -1.0f );
		glVertex3f(-0.5f,  -0.4f, -1.0f );
		
		/* Corner */
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 1.0f,  -0.4f, -0.5f );
		glVertex3f( 0.5f,  -0.4f, -0.5f );
		glVertex3f( 0.5f,  -0.4f, -1.0f );
		
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f(-1.0f,  -0.4f, -0.5f );
		glVertex3f(-0.5f,  -0.4f, -0.5f );
		glVertex3f(-0.5f,  -0.4f, -1.0f );
		
		/* Right */
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 1.0f,  -0.4f,  0.0f );
		glVertex3f( 1.0f,  -0.4f, -0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.5f,  -0.4f, -0.5f );
		glVertex3f( 1.0f,  -0.4f, -0.5f );
		
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 1.0f,  -0.4f,  0.0f );
		glVertex3f( 1.0f,  -0.4f,  0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 0.5f,  -0.4f,  0.0f );
		glVertex3f( 0.5f,  -0.4f,  0.5f );
		glVertex3f( 1.0f,  -0.4f,  0.5f );
		
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f( 1.0f,  -0.4f,  0.5f );
		glVertex3f( 0.5f,  -0.4f,  0.5f );
		glVertex3f( 0.5f,  -0.4f,  1.0f );

		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f( 1.0f,  -0.4f,  0.5f );
		glVertex3f( 1.0f,  -0.4f,  1.0f );
		glVertex3f( 0.5f,  -0.4f,  1.0f );
		
		/* Left */
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f(-1.0f,  -0.4f,  0.0f );
		glVertex3f(-1.0f,  -0.4f, -0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f(-0.5f,  -0.4f, -0.5f );
		glVertex3f(-1.0f,  -0.4f, -0.5f );
		
		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f(-1.0f,  -0.4f,  0.0f );
		glVertex3f(-1.0f,  -0.4f,  0.5f );

		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f(-0.5f,  -0.4f,  0.0f );
		glVertex3f(-0.5f,  -0.4f,  0.5f );
		glVertex3f(-1.0f,  -0.4f,  0.5f );
		
		glColor4f(0.35f, 0.25f, 0.25f, 1.0f);
		glVertex3f(-1.0f,  -0.4f,  0.5f );
		glVertex3f(-0.5f,  -0.4f,  0.5f );
		glVertex3f(-0.5f,  -0.4f,  1.0f );

		glColor4f(0.30f, 0.20f, 0.20f, 1.0f);
		glVertex3f(-1.0f,  -0.4f,  0.5f );
		glVertex3f(-1.0f,  -0.4f,  1.0f );
		glVertex3f(-0.5f,  -0.4f,  1.0f );
		
	glEnd();
	
	/* Render Cockpit */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glBegin(GL_QUADS);
	
		glColor4f( 0.35f, 0.25f, 0.25f, 1.0f );	
		glVertex3f(-0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f, -0.4f, 0.0f );
		glVertex3f(-0.5f, -0.4f, 0.0f );
		
		glColor4f( 0.30f, 0.20f, 0.20f, 1.0f );
		glVertex3f( 0.5f, -0.5f, 1.0f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f, -0.4f, 0.0f );
		glVertex3f( 0.5f, -0.4f, 1.0f );
		
		glColor4f( 0.30f, 0.20f, 0.20f, 1.0f );
		glVertex3f(-0.5f, -0.5f, 1.0f );
		glVertex3f(-0.5f, -0.5f, 0.0f );
		glVertex3f(-0.5f, -0.4f, 0.0f );
		glVertex3f(-0.5f, -0.4f, 1.0f );
		
	glEnd(); 
	#endif
	
	#ifdef COK
	/* Render Cockpit */
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_QUADS);
	
		/* Cockpit */
		glColor4f( 0.90f, 0.90f, 0.90f, 1.0f);
		glVertex3f(-0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f,  0.3f, 0.3f );
		glVertex3f(-0.3f,  0.3f, 0.3f );
		
		/* Line */
		glColor4f( 0.4f -VA1,0.3f -VA1,0.3f -VA1,1.0f );	
		glVertex3f(-0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f( 0.5f,  0.5f, 0.0f );
		glVertex3f(-0.5f,  0.5f, 0.0f );
		
		glVertex3f(-0.5f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f(-0.5f, -0.5f, 0.0f );
		
		glVertex3f(-0.5f,  0.5f, 1.5f );
		glVertex3f( 0.5f,  0.5f, 1.5f );
		glVertex3f( 0.5f,  0.5f, 0.0f );
		glVertex3f(-0.5f,  0.5f, 0.0f );
		
		/* Terminal */
		glColor4f( 0.80f, 0.40f, 0.25f, 1.0f);	
		glVertex3f(-2.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f( 2.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f( 2.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f(-2.0f, 0.60f + rootY, 0.5f -viewZ );
		
	glEnd();
	
	/* Render Points */
	glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
	glBegin(GL_POINTS);
	/*glBegin(GL_QUADS);*/
		
		/* Point */
		glColor4f(  0.00f, 1.00f, 0.00f, 1.0f);	
		glVertex3f(-0.45f, -0.45f, 0.15f );
		glVertex3f( 0.45f, -0.45f, 0.15f );
		glVertex3f( 0.45f,  0.45f, 0.15f );
		glVertex3f(-0.45f,  0.45f, 0.15f );
		
		glColor4f(  1.00f, 0.50f, 0.00f, 1.0f);
		glVertex3f(-0.45f, -0.45f, 0.99f );
		glVertex3f( 0.45f, -0.45f, 0.99f );
		glVertex3f( 0.45f, -0.45f, 0.15f );
		glVertex3f(-0.45f, -0.45f, 0.15f );
		
		glColor4f(  1.00f, 1.00f, 0.00f, 1.0f);
		glVertex3f(-0.45f,  0.45f, 0.99f );
		glVertex3f( 0.45f,  0.45f, 0.99f );
		glVertex3f( 0.45f,  0.45f, 0.15f );
		glVertex3f(-0.45f,  0.45f, 0.15f );
		
	glEnd();
	
	/* Render Cockpit */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glBegin(GL_POINTS);
	/*glBegin(GL_QUADS);*/
	
		/* Red */
		glColor4f( 1.0f, 0.0f, 0.0f, 1.0f );
		glVertex3f(-0.3f,  0.3f, 0.31f );
		/* Blue */
                glColor4f( 0.0f, 0.0f, 1.0f, 1.0f );
                glVertex3f( 0.3f,  0.3f, 0.31f );
		/* Green */
		glColor4f( 0.0f, 1.0f, 0.0f, 1.0f );
		glVertex3f( 0.3f, -0.2f, 0.31f );
		/* Black */
                glColor4f( 0.0f, 0.0f, 0.0f, 1.0f );
                glVertex3f(-0.3f, -0.2f, 0.31f );
		
	glEnd();
	
	/* Render Quads */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glBegin(GL_QUADS);
	
		/* Instruments */
		glColor4f(0.9f -VA8,0.9f -VA8,0.9f -VA8,0.4f);		
		glVertex3f(-0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f, -0.2f, 0.3f );
		glVertex3f( 0.3f,  0.3f, 0.3f );
		glVertex3f(-0.3f,  0.3f, 0.3f );
		
		/* Ebene Down */
		glColor4f( 0.20f, 0.20f, 0.20f, 1.0f );
		glVertex3f(-0.5f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 1.5f );
		glVertex3f( 0.5f, -0.5f, 0.0f );
		glVertex3f(-0.5f, -0.5f, 0.0f );
		
		/* Ebene Up */
		glColor4f( 0.20f, 0.20f, 0.20f, 1.0f );
		glVertex3f( 0.5f, 0.5f, 1.5f );
		glVertex3f(-0.5f, 0.5f, 1.5f );
		glVertex3f(-0.5f, 0.5f, 0.0f );
		glVertex3f( 0.5f, 0.5f, 0.0f );
		
		/* Terminal */
		glColor4f( 0.05f, 0.10f, 0.15f, 0.9f);
		glVertex3f(-2.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f( 2.0f, 0.60f + rootY, 0.5f -viewZ );
		glVertex3f( 2.0f, 0.64f + rootY, 0.5f -viewZ );
		glVertex3f(-2.0f, 0.64f + rootY, 0.5f -viewZ );

		glColor4f( 0.0f, 0.0f, 0.0f, 0.8f);
		glVertex3d(-2.0f, 0.6f + rootY, 0.5f -viewZ );
		glVertex3d( 2.0f, 0.6f + rootY, 0.5f -viewZ );
		glVertex3d( 2.0f, 1.1f + rootY, 0.5f -viewZ );
		glVertex3d(-2.0f, 1.1f + rootY, 0.5f -viewZ );
	
	glEnd();
	#endif
	
	/* Render Quads */
	glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
	glBegin(GL_QUADS);
	
		/* Night Look */
		glColor4f( 0.00f, 1.00f, 0.00f, 0.0f -nightV);
		glVertex3d(-2.0f,-1.0f, 0.5f -viewZ );
		glVertex3d( 2.0f,-1.0f, 0.5f -viewZ );
		glVertex3d( 2.0f, 1.0f, 0.5f -viewZ );
		glVertex3d(-2.0f, 1.0f, 0.5f -viewZ );
		glColor4f( 1.00f, 1.00f, 1.00f, 1.0f);

	glEnd();	
	glDisable(GL_DEPTH_TEST);
	glDisable(GL_BLEND);
}

/*---------------------------------------------------------------------------*/

/* Process Event */
void process_event(XEvent report)
{   
	KeySym key;
	key = XLookupKeysym (&report.xkey, 0);
	
	/* Keyboard Control Keys */	
	switch(key)
	{		
		case XK_Up: 
		pitch -= 0.10f; 
		break;

		case XK_Down: 
		pitch += 0.10f; 
		break;

		case XK_Left: 
		roll += 0.20f; 
		break;

		case XK_Right: 
		roll -= 0.20f; 
		break;

		case XK_e: 
		yaw += 0.10f; 
		break;

		case XK_q: 
		yaw -= 0.10f; 
		break;

		case XK_a: 
		planeX -= 0.02f; 
		break;
		
		case XK_d: 
		planeX += 0.02f; 
		break;

		case XK_w: 
		planeY += 0.01f; 
		break;

		case XK_s: 
		planeY -= 0.01f; 
		break;

		case XK_b: 
		planeZ += 0.02f; 
		break;

		case XK_space: 
		planeZ -= 0.02f; 
		break;

		case XK_x: 
		viewZ =  0.00f; 
		break;

		case XK_y: 
		viewZ = -0.50f;
		break;
		
		case XK_m: 
		nightV = +0.20f;
		break;

		case XK_n: 
		nightV = -0.20f;
		break;

		case XK_F1: 
		rootY = -0.60f; 
		break;

		case XK_F2: 
		rootY = +0.60f; 
		break;

		case XK_F3: 
		VA1 = +0.10f;
		VA7 = +0.70f; 
		VA8 = +0.89f; 
		break;

		case XK_F4: 
		VA1 = -0.10f;    
		VA7 = -0.70f; 
		VA8 = -0.89f; 
		break;

		case XK_Escape: 
		closeWin(); 
		break;
	}
}

/*---------------------------------------------------------------------------*/

